
 ; **************************************************************************
 ; *                                                                        *
 ; *          Galaxian - Copyright 1997-1998 by Patrick Davidson            *
 ; *                                                                        *
 ; **************************************************************************

         .include "asm86.h"           
         .include "ti86asm.inc"
         .include "ti86abs.inc"
         .org     _asm_exec_ram
         nop
         jp       Start
         .dw      0
         .dw      Title
Title:   .db      "Galaxian 2.05 by PAD",0
Start:   ld       (OTH_EXIT+1),sp
         call     _runindicoff

 ; *************** Temporary Variables **************************************

enemy_coords      =$8000             
enemy_image       =$8028            
boss_image        =$802a               
enemy_pwr         =$802c
temp1             =$802e          
temp              =$8030
next_type         =$8032
jpf1              =$8033
jpf2              =$8034
contrst           =$8035

 ; *************** Initialize Control Flags *********************************

init:
         set      0,(iy+3)
         ld       (iy+13),0

         ld       a,(CONTRAST)
         cp       $1f
         jr       z,no_inc1
         inc      a
no_inc1: out      (2),a
         ld       (contrst),a

 ; *************** Main Loop ************************************************

         ld       de,title_message
         ld       hl,title_menu
         call     display_info_screen

main_loop:
         call     _getkey

         cp       kExit
         jr       z,exit_game
         cp       kClear
         jr       z,exit_game
         cp       kF1
         jr       z,inst

         cp       kEnter
         jr       nz,main_loop
         call     wait_no_enter
         call     play_game
         jp       game_over

inst:
         ld       de,igc
         ld       hl,instructions
         call     display_info_screen
         jr       main_loop

 ; *************** Exit The Game ********************************************

exit_game:
         ld       a,(CONTRAST)
         out      (2),a

 ; ************** BASIC ROUTINE LIBRARY *************************************

OTH_EXIT:
         ld       sp,0                       ; Restore stack pointer

         ld       (iy+13),6                  ; Restore system flags

         ld       hl,own_name                ; Find own variable
         ld       a,0
         call     _ABS_MOV10TOOP1
         call     _FINDSYM
         jr       c,final_exit               ; If not found, give up

         ld       a,b                        ; Save the stored section
         ld       h,d
         ld       l,e
         ld       b,0
         ld       de,4+stored_data_start-_asm_exec_ram
         add      hl,de
         adc      a,b
         call     _SET_ABS_DEST_ADDR
         ld       a,0
         ld       hl,stored_data_start
         call     _SET_ABS_SRC_ADDR
         ld       hl,stored_data_end-stored_data_start
         call     _SET_MM_NUM_BYTES
         call     _mm_ldir

final_exit:                                  ; Quit the program completely
         ei
         ld       hl,TEXT_MEM
         ld       bc,167
         call     OTH_CLEAR
         ld       hl,0
         ld       (_curRow),hl
         jp       _clrScrn

own_name:
         .db      $12,8,"Galaxian"

OTH_CLEAR:
         ld       d,h
         ld       e,l
         ld       (hl),0
         inc      de
         ldir
         ret

_D_HL_DECI:
         push     bc
         ld       de,up_data+4
         ld       b,5
ldhld:   call     UNPACK_HL
         add      a,48
         ld       (de),a
         dec      de
         djnz     ldhld
         ld       hl,up_data
         ld       b,4
lis:     ld       a,(hl)
         cp       48
         jr       nz,dis
         ld       (hl),32
         inc      hl
         djnz     lis
dis:     ld       hl,up_data
         call     _puts
         pop      bc
         ret

up_data: .db      "PAD98",0

 ; **************** High-Score Handling *************************************

chartable:
         .db      0,0,0,0,0,":",0,0
         .db      0,0,0,0,"+-*/"
         .db      "^()[]=",0,0
         .db      ",",0,0,0,"0123"
         .db      "456789",0," "
         .db      "ABCDEFGH"
         .DB      "IJKLMNOP"
         .db      "QRSTUVWX"
         .DB      "YZabcdef"
         .db      "ghijklmn"
         .db      "opqrstuv"
         .db      "wxyz"

game_over:                                   ;Set up score page
         ld       hl,lowest                  ;See if ya got a hi-score
         call     LD_HL_MHL
         ld       de,(score)
         call     CP_HL_DE
         jp       nc,display_scores
         call     _clrLCD
         ld       (_curRow),de
         ld       hl,hi_score_str
         call     _puts

         ld       hl,lowest+2

         ld       (temp),hl
         ld       b,16
         ld       c,32
space_loop:
         ld       (hl),c
         inc      hl
         djnz     space_loop
         ld       ix,(temp)
         ld       b,0
enter_name_loop:
         ld       a,'_'
         call     _putc
         ld       hl,_curCol
         dec      (hl)
         call     _getkey
         cp       kDel
         jr       z,backup
         cp       kLeft
         jr       z,backup
         cp       kEnter
         jr       z,nomore

         cp       $5B
         jp       p,enter_name_loop
         ld       c,a
         ld       a,15
         cp       b
         jr       z,enter_name_loop

         ld       hl,chartable
         ld       e,c
         ld       d,0
         add      hl,de
         ld       a,(hl)
         or       a
         jr       z,enter_name_loop

         ld       (ix),a
         call     _putc  
         inc      b
         inc      ix
         jr       enter_name_loop

backup:  dec      b
         ld       a,255
         cp       b
         jr       z,too_far
         dec      ix
         ld       (ix),' '
         ld       a,32
         call     _putc
         ld       hl,_curCol
         dec      (hl)
         dec      (hl)
         jr       enter_name_loop
too_far: inc      b
         jr       enter_name_loop

nomore:
         ld       hl,(score)
         ld       (lowest),hl
         ld       ix,lowest
         ld       b,6
sort_scores:
         ld       e,(ix)
         ld       d,(ix+1)
         ld       l,(ix-19)
         ld       h,(ix-18)
         call     CP_HL_DE
         jr       nc,display_scores
         push     bc
         ld       b,19
         ld       d,0
exg_loop:ld       e,(ix)
         ld       c,(ix-19)
         ld       (ix),c
         ld       (ix-19),e
         inc      ix
         djnz     exg_loop
         ld       de,-38
         add      ix,de
         pop      bc
         djnz     sort_scores

display_scores:
         call     _clrLCD 
         ld       (_curRow),de
         ld       hl,hstitle
         call     _puts
         ld       hl,$1001
         ld       (_curRow),hl

         ld       de,hsdata
         ld       b,7
high_display_loop:                           ;Display high scores
         ld       a,(de)
         ld       l,a
         inc      de
         ld       a,(de)
         ld       h,a
         inc      de
         push     de
         call     _D_HL_DECI
         ld       hl,_curRow
         dec      (hl)
         pop      hl
         call     _puts
         ex       de,hl
         ld       hl,_curRow
         inc      (hl)
         djnz     high_display_loop
wk__:    call     _getkey
         or       a
         jr       z,wk__
         jp       exit_game

 ; *************** Display Information Screen *******************************

display_info_screen:

         push     hl
         push     de
         call     _clrLCD

         ld       hl,$fc0f
         ld       b,63
         ld       de,15
l2:      ld       (hl),1
         inc      hl
         ld       (hl),128
         add      hl,de
         djnz     l2
         ld       hl,$fc00
         ld       b,16
l1:      ld       (hl),255
         inc      hl
         djnz     l1
         ld       hl,$fff0
         ld       b,16
l3:      ld       (hl),255
         inc      hl
         djnz     l3

         ld       de,$0301
         ld       (_curRow),de
         pop      hl
         call     _puts
         pop      hl

         ld       b,5
l4:      ld       a,(hl)
         ld       (CURSOR_X),a
         inc      hl
         ld       a,(hl)
         ld       (CURSOR_Y),a
         inc      hl
         call     D_ZM_STR)
         djnz     l4
         ret

 ; *************** Restore Saved Game ***************************************


restore: ld       (hl),0
         call     Load_Level_Data
         jr       set_up_display

 ; *************** Set Up Game Variables ************************************

play_game:
         ld       hl,saved_flag
         ld       a,(hl)
         or       a
         jr       nz,restore
         ld       hl,stored_data_start
         ld       bc,variables_end-stored_data_start-1
         call     OTH_CLEAR
         ld       a,3
         ld       (lasers),a
         ld       (lives),a
         ld       a,70
         ld       (x),a
         ld       (y),a

 ; *************** Set Up Game Display **************************************

set_up_display:
         call     _clrLCD

         ld       hl,in_game_text
         ld       b,3
l11:     ld       a,(hl)
         ld       (_curCol),a
         inc      hl
         ld       a,(hl)
         ld       (_curRow),a
         inc      hl
         call     _puts
         djnz     l11

         call     display_lives
         call     Update_Level_Number

         ld       a,(warped_status)
         cp       1
         call     z,warp_disp

 ; *************** Game Main Loop *******************************************

game_main_loop:
         ld       a,(enemies_remaining)
         or       a
         call     z,Next_Level
         ld       hl,timer
         inc      (hl)

         xor      a
         ld       hl,GRAPH_MEM+(16*12)
         ld       b,a
csl:     ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         djnz     csl

         call     You_Shoot
         call     You_Shoot_Laser
         call     Your_Ship
         call     Move_Your_Bullets
         call     Enemy_Swoop
         call     Handle_Enemies
         CALL     Enemies_Hit_You
         call     Boss
         call     Boss_Shoot
         call     Enemies_Shoot_You
         call     Move_Enemy_Bullets
         call     Display_Screen
         call     Misc_Keys
         jr       game_main_loop

 ; ************** Update Level Number ***************************************

Update_Level_Number:
         ld       hl,$1004
         ld       (_curRow),hl
         ld       hl,(level)
         jp       _D_HL_DECI

 ; *************** Make Boss Shoot You **************************************

Boss_Shoot:
         ld       a,(timer)
         and      63
         ret      nz
         ld       hl,boss_status
         ld       a,(hl)
         or       a
         ret      z
         ret      m
         inc      hl
         inc      hl
         ld       d,(hl)
         inc      hl
         ld       a,(hl)
         add      a,5
         ld       e,a
         push     de
         call     boss_shoot
         pop      de
         ld       a,13
         add      a,d
         ld       d,a

boss_shoot:
         ld       b,10
         ld       hl,ebuls
find_enemy_bullet2:
         ld       a,(hl)
         or       a
         jr       z,feb___2
         inc      hl
         inc      hl
         inc      hl
         djnz     find_enemy_bullet2
         ret

feb___2:
         ld       (hl),1
         ld       a,(x)
         sub      d
         add      a,18
         jp       p,no_left_bossshoot
         ld       (hl),2
         add      a,18
         jp       p,no_left_bossshoot
         ld       (hl),4
no_left_bossshoot:
         sub      54
         jp       m,no_right_bossshoot
         ld       (hl),3
         sub      18
         jp       m,no_right_bossshoot
         ld       (hl),5
no_right_bossshoot:

         inc      hl
         ld       (hl),d
         inc      hl
         ld       (hl),e
         ret

 ; *************** Move the Boss ********************************************

Boss:    ld       hl,boss_status
         ld       a,(hl)
         or       a
         ret      z
         jp       m,boss_explode

         inc      hl
         inc      hl
         ld       ix,(boss_image)
         ld       d,(hl)
         inc      hl
         ld       e,(hl)
         call     drw_sprw
         ld       hl,boss_status
         ld       a,(hl)
         inc      hl
         inc      hl
         dec      a
         jr       z,boss_1
         dec      a
         jr       z,boss_2
         dec      a
         jr       z,boss_3
         dec      a
         jr       z,boss_4

boss_4:  dec      (hl)                       ;Going left to X=1
         ld       a,(hl)
         cp       1
         ret      nz
         dec      hl
         dec      hl
         ld       (hl),1
         ret

boss_1:  inc      hl                         ;Going down to Y=20
         inc      (hl)
         ld       a,(hl)
         cp       20
         ret      nz
boss_common:
         ld       hl,boss_status
         inc      (hl)
         ret

boss_2:  inc      (hl)                       ;Going right to X=80
         ld       a,(hl)
         cp       80
         ret      nz
         jr       boss_common

boss_3:  inc      hl                         ;Going up to X=16
         dec      (hl)
         ld       a,(hl)
         cp       16
         ret      nz
         jr       boss_common


boss_explode:
         inc      hl
         push     hl
         ld       a,(hl)
         call     explosion_stuff
         pop      hl
         inc      hl
         ld       a,(hl)
         push     af
         push     hl
         add      a,8
         ld       (hl),a
         dec      hl
         ld       a,(hl)
         call     explosion_stuff
         pop      hl
         pop      af
         ld       (hl),a
         dec      hl
         ld       a,(hl)
         cp       15
         jr       z,blown_up_enemyb
         inc      a
         ld       (hl),a
         ret

blown_up_enemyb:
         dec      hl
         ld       (hl),0
         ld       hl,enemies_remaining
         dec      (hl)
         ld       hl,(score)
         ld       de,1000
         add      hl,de
         ld       (score),hl
         ret

 ; *************** Enemies Hit You ******************************************

Enemies_Hit_You:
         ld       a,(your_status)
         or       a
         ret      nz
         ld       de,(x)                     ;E = X, D = Y
         ld       hl,enemies
         ld       b,20
lehy:    push     hl
         ld       a,(hl)
         or       a
         jr       z,noeyc
         inc      hl
         inc      hl
         ld       a,(hl)
         sub      e
         add      a,6
         jp       m,noeyc
         cp       12
         jr       nc,noeyc
         inc      hl
         ld       a,(hl)
         sub      d
         add      a,6
         jp       m,noeyc
         cp       12
         jr       nc,noeyc
         dec      hl
         dec      hl
         ld       (hl),0
         dec      hl
         ld       (hl),4
         pop      hl
         jp       damage_you
noeyc:   pop      hl
         inc      hl
         inc      hl
         inc      hl
         inc      hl
         djnz     lehy
         ret

 ; *************** Make Enemies Swoop Down **********************************

Enemy_Swoop:
         ld       a,(timer)
         and      3
         cp       2
         ret      nz
         ld       a,r
         and      127
         cp       19
         ret      p

         add      a,a
         add      a,a
         ld       c,a
         ld       b,0
         ld       hl,enemies
         add      hl,bc
         ld       a,(hl)
         cp       3
         ret      nz

         ld       de,(score)
         ld       a,d
         or       e
         jr       z,nodec
         dec      de
         ld       (score),de
nodec:

         ld       a,r
         and      1
         add      a,5
         ld       (hl),a
         inc      hl
         inc      hl
         ld       a,(hl)
         dec      hl
         dec      hl
         bit      6,a
         jr       nz,force_left
         bit      5,a
         ret      nz
         ld       (hl),5
         ret
force_left:
         ld       (hl),6
         ret

 ; *************** Make Enemies Shoot You ***********************************

Enemies_Shoot_You:
         ld       a,r
         and      127
         cp       19
         ret      p
         add      a,a
         add      a,a
         ld       c,a
         ld       b,0
         ld       hl,enemies
         add      hl,bc
         ld       a,(hl)
         or       a
         ret      z
         dec      a
         ret      z
         inc      hl
         inc      hl
         ld       c,(hl)
         inc      c
         inc      hl
         ld       a,(hl)
         add      a,5
         ld       e,a
         ld       b,10
         ld       hl,ebuls
find_enemy_bullet:
         ld       a,(hl)
         or       a
         jr       z,feb___
         inc      hl
         inc      hl
         inc      hl
         djnz     find_enemy_bullet
         ret

feb___:  ld       (hl),1
         inc      hl
         ld       (hl),c
         inc      hl
         ld       (hl),e
         ret         

 ; *************** Move Enemy Bullets ***************************************

Move_Enemy_Bullets:
         ld       hl,ebuls
         ld       b,10
leb:     push     bc
         push     hl
         ld       a,(hl)
         inc      hl
         dec      a
         jr       z,ebul1
         dec      a
         jr       z,ebul2
         dec      a
         jr       z,ebul3
         dec      a
         jr       z,ebul4
         dec      a
         jr       z,ebul5
ebul_return:
         pop      hl
         pop      bc
         inc      hl
         inc      hl
         inc      hl
         djnz     leb
         ret


ebul3:   ld       a,(timer)
         rra
         jr       c,ebul1
ebul5:   inc      (hl)
         ld       a,(hl)
         cp       95
         jr       z,kill_enemy_bullet
         jr       ebul1

ebul2:   ld       a,(timer)
         rra
         jr       c,ebul1
ebul4:   dec      (hl)
         jr       z,kill_enemy_bullet

ebul1:   ld       d,(hl)
         inc      hl
         ld       a,81
         cp       (hl)
         jr       z,kill_enemy_bullet
         inc      (hl)
         ld       e,(hl)
         ld       ix,spr_enemy_bullet
         call     drw_spr
         ld       a,(your_status)
         or       a
         jr       nz,ebul_return
         pop      hl
         push     hl

         inc      hl
         ld       a,(x)
         sub      (hl)
         add      a,6
         jp       m,ebul_return
         cp       9
         jr       nc,ebul_return

         inc      hl
         ld       a,(y)
         sub      (hl)
         add      a,6
         jp       m,ebul_return
         cp       9
         jr       nc,ebul_return

         call     damage_you

kill_enemy_bullet:
         pop      hl
         push     hl
         ld       (hl),0
         jr       ebul_return

 ; *************** Hit Your Ship ********************************************

damage_you:

         ld       a,31
         ld       (your_status),a
         ld       hl,lives
         dec      (hl)
display_lives:
         ld       hl,$1001
         ld       (_curRow),hl
         ld       hl,(lives)
         jp       _D_HL_DECI

 ; *************** Enemy Type 1 (Waiting to Descend) ************************

enemy_type_1:
         ld       a,(timer)
         and      127
         or       %10000000

         ld       hl,enemy_coords-1
         add      hl,bc
         add      a,(hl)
         RET      NZ
         dec      hl
         ld       a,(hl)
         pop      BC
         POP      HL
         PUSH     HL
         push     BC
         ld       (hl),2
         inc      hl
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (hl),0
         RET
         
 ; *************** Move The Enemies *****************************************

Handle_Enemies:
         ld       hl,enemies
         ld       bc,40
l_enemies:
         push     bc
         push     hl
         ld       ix,(enemy_image)
         ld       a,14
         cp       c
         jr       nc,no_i2
         ld       a,(boss_image)
         inc      a
         jr       nz,no_i2
         ld       ix,spr_enemy_1
no_i2:
         ld       a,(hl)
         ld       de,enemy_return
         push     de

         dec      a
         jr       z,enemy_type_1
         dec      a
         jr       z,enemy_type_2
         dec      a
         jr       z,enemy_type_3
         dec      a
         jr       z,enemy_type_4
         dec      a
         jp       z,enemy_type_5
         dec      a
         jp       z,enemy_type_6
         dec      a
         jp       z,enemy_type_7
         dec      a
         jp       z,enemy_type_8
         dec      a
         jp       z,enemy_type_9
         dec      a
         jp       z,enemy_type_10
         dec      a
         jp       z,enemy_type_11
         dec      a
         jp       z,enemy_type_12
         dec      a
         jp       z,enemy_type_13
         pop      HL
enemy_return:
         pop      hl
         pop      bc
         inc      hl
         inc      hl
         inc      hl
         inc      hl
         dec      c
         dec      c
         jr       nz,l_enemies
         ret

 ; *************** Enemy Type 2 (Descending to Normal Position) *************

enemy_type_2:
         ld       a,(timer)
         and      127
         jr       z,make_type_3
         inc      hl
         inc      hl
         ld       d,(hl)
         inc      hl
         inc      (hl)
ecommon_2:
         ld       e,(hl)
         JP       drw_spr

make_type_3:
         ld       (hl),3

 ; **************** Enemy Type 3 (Normal Pattern) ***************************

enemy_type_3:
         Inc      hl
         inc      hl
         ld       a,(timer)
         rra
         jr       c,noslide
         inc      (hl)
         bit      5,a
         jr       z,noslide
         dec      (hl)
         dec      (hl)
noslide: ld       d,(hl)
         inc      hl
         jr       ecommon_2

 ; *************** Enemy Type 4 (Exploding) *********************************

enemy_type_4:
         inc      hl
         push     hl
         ld       a,(hl)

         call     explosion_stuff

         pop      hl
         ld       a,(hl)
         cp       15
         jr       z,blown_up_enemy
         inc      a
         ld       (hl),a
         RET

blown_up_enemy:
         dec      hl
         ld       (hl),0
         ld       hl,enemies_remaining
         dec      (hl)
         ld       hl,(score)
smc_scoring:
         ld       de,100
         add      hl,de
         ld       (score),hl
         RET

 ; *************** Enemy Type 5 (Swooping Up + Right) ***********************

enemy_type_5:
         ld       a,7
         ld       bc,$01FF
enemy_common:
         inc      hl
         inc      hl

         ld       (next_type),a
         ld       a,b
         add      a,(hl)
         ld       (hl),a
         ld       d,a
         inc      hl
         ld       a,c
         add      a,(hl)
         ld       (hl),a
         ld       e,a
         call     drw_spr
         ld       a,(timer)
         and      3
         RET      nz
         POP      BC
         pop      hl
         push     hl
         PUSH     BC
         ld       a,(next_type)
         ld       (hl),a
         RET

 ; *************** Enemy Type 6 (Swooping Up + Left) ************************

enemy_type_6:
         ld       a,8
         ld       bc,$FFFF
         jr       enemy_common

 ; *************** Enemy Type 7 (Swooping Right) ****************************

enemy_type_7:
         ld       a,9
         ld       bc,$0100
         jr       enemy_common

 ; *************** Enemy Type 8 (Swooping Left) *****************************

enemy_type_8:
         ld       a,10
         ld       bc,$ff00
         jr       enemy_common

 ; *************** Enemy Type 9 (Swooping Right / Down) *********************

enemy_type_9:
         ld       bc,$0101
         ld       a,11
         jr       enemy_common

 ; *************** Enemy Type 10 (Swooping Left / Down) *********************

enemy_type_10:
         ld       bc,$ff01  
         ld       a,11
         jr       enemy_common

 ; *************** Enemy Type 11 (Swooping Down) ****************************

enemy_type_11:
         ld       a,12
         ld       bc,$0001
         jr       enemy_common

 ; *************** Enemy Type 12 (Swooping Down Quickly) ********************

enemy_type_12:
         inc      hl
         inc      hl
         ld       d,(hl)
         inc      hl
         inc      (hl)
         inc      (hl)
         ld       e,(hl)
         ld       a,78
         cp       e
         jr       c,enemy_restore
         JP       drw_spr
            
enemy_restore:
         POP      BC
         pop      hl
         push     hl
         PUSH     BC
         ld       (hl),1
         RET

 ; *************** Enemy Type 13 (Warp Enemy) *******************************

enemy_type_13:
         inc      hl
         inc      hl
         ld       a,(hl)
         inc      hl
         inc      hl
         inc      hl
         add      a,(hl)
         ld       d,a

         cp       1
         jr       nz,et13_not_x_2
         ld       (hl),1
et13_not_x_2:
         cp       23
         jr       nz,et13_not_x_23
         ld       (hl),1
         ld       a,r
         rra
         jr       c,et13_not_x_23
         ld       (hl),-1
et13_not_x_23:
         cp       45
         jr       nz,et13_not_x_45
         ld       (hl),1
         ld       a,r
         rra
         jr       c,et13_not_x_45
         ld       (hl),-1
et13_not_x_45:
         cp       87
         jr       nz,et13_not_x_87
         ld       (hl),-1
et13_not_x_87:

         dec      hl
         dec      hl
         dec      hl
         ld       (hl),d

         inc      hl
         ld       a,(hl)
         inc      hl
         inc      hl
         inc      hl
         add      a,(hl)
         ld       e,a         

         cp       15
         jr       nz,et13_not_y_15
         ld       (hl),1
et13_not_y_15:
         cp       27
         jr       nz,et13_not_y_27
         ld       (hl),1
         ld       a,r
         rra
         jr       c,et13_not_y_27
         ld       (hl),-1
et13_not_y_27:
         cp       39
         jr       nz,et13_not_y_39
         ld       (hl),-1
et13_not_y_39:

         dec      hl
         dec      hl
         dec      hl
         ld       (hl),e
         
         ld       ix,enemy_warped
         jp       drw_spr

 ; *************** Shoot Your Lasers ****************************************

You_Shoot_Laser:

         ld       hl,jpf2                    ;Test if F2 clicked
         in       a,(1)
         bit      3,a
         jr       z,pressed2
         ld       (hl),0
         ret

pressed2:ld       a,(hl)
         or       a
         ret      nz
         ld       (hl),1

         ld       hl,lasers                  ;Test # of lasers
         ld       a,(hl)
         dec      a
         ret      m
         ld       (hl),a
         ld       a,(x)
         add      a,3

         ld       d,0                        ;Draw laser
         ld       e,a
         and      7                       
         ld       hl,offsets_table         
         ld       c,a                       
         ld       b,0                       
         add      hl,bc                     
         ld       a,(hl)                  
         srl      e
         srl      e
         srl      e

         ld       hl,GRAPH_MEM
         add      hl,de
         ld       b,84
         ld       de,12
ldrawlaser:
         ld       (hl),a
         add      hl,de
         djnz     ldrawlaser

         ld       a,(x)                      ;Laser kills enemies
         add      a,3
         ld       e,a
         ld       hl,enemies
         ld       b,20
l_laser: ld       a,(hl)
         inc      hl
         inc      hl
         or       a
         jr       z,nohitl
         dec      a
         jr       z,nohitl
         cp       3
         jr       z,nohitl
         ld       a,e
         sub      (hl)
         and      248
         jr       nz,nohitl
         dec      hl
         ld       (hl),0
         dec      hl
         ld       (hl),4
         inc      hl
         inc      hl
nohitl:  inc      hl
         inc      hl
         djnz     l_laser

         ret

 ; *************** Allow You To Shoot ***************************************

You_Shoot:
         ld       a,%00111111
         out      (1),a
         ld       a,(your_status)
         or       a
         ret      nz
         ld       hl,jpf1
         in       a,(1)
         bit      4,a
         jr       z,pressed
         ld       (hl),0
         ret

pressed: ld       a,(hl)
         or       a
         ret      nz
         ld       (hl),1

         ld       hl,ybullets
         ld       de,3
         ld       b,10
find_ybullet:
         ld       a,(hl)
         or       a
         jr       z,found_ybullet
         add      hl,de
         djnz     find_ybullet
         ret

found_ybullet:
         ld       (hl),1
         inc      hl
         ld       a,(x)
         add      a,2
         ld       (hl),a
         ld       a,(y)
         sub      4
         inc      hl
         ld       (hl),a
         ret

 ; *************** Move Your Bullets ****************************************

kill_bullet:
         dec      hl
         dec      hl
         ld       (hl),0
         ret

Move_Your_Bullets:
         ld       hl,ybullets
         ld       b,10
scan_your_bullets:
         push     bc
         push     hl
         ld       (temp1),hl
         ld       a,(hl)
         inc      hl
         dec      a
         call     z,bullet_type_1
         pop      hl
         pop      bc
         ld       de,3
         add      hl,de  
         djnz     scan_your_bullets
         ret

bullet_type_1:

         ld       d,(hl)
         inc      hl
         ld       e,(hl)
         dec      e
         jr       z,kill_bullet
         dec      e
         jr       z,kill_bullet
         ld       (hl),e
         ld       ix,spr_bullet_1
         push     de
         call     drw_spr
         pop      de
         ld       b,20
         ld       hl,enemies

hit_enemies:                                 ;Hits with normal enemies
         push     hl

         ld       a,(hl)
         or       a
         jr       z,nohit
         dec      a
         jr       z,nohit
         cp       3
         jr       z,nohit

         inc      hl
         inc      hl

         ld       a,(hl)
         sub      d
         add      a,5
         jp       m,nohit
         cp       8
         jr       nc,nohit

         inc      hl
         ld       a,(hl)
         sub      e
         add      a,5
         jp       m,nohit
         cp       10
         jr       nc,nohit

         push     hl
         ld       hl,(temp1)
         ld       (hl),0
         pop      hl

         dec      hl
         dec      hl
         dec      (hl)
         jr       nz,nohit
         ld       (hl),0
         dec      hl
         ld       (hl),4

         ld       hl,(score)
         ld       de,20
         add      hl,de
         ld       (score),hl
         pop      hl
         ret
         
nohit:   pop      hl
         inc      hl
         inc      hl
         inc      hl
         inc      hl
         djnz     hit_enemies

         ld       hl,boss_status             ;Hits with boss
         ld       a,(hl)
         or       a
         ret      m
         ret      z
         inc      hl
         inc      hl
         ld       a,(hl)
         sub      d
         add      a,15
         ret      m
         cp       18
         ret      p

         inc      hl
         ld       a,(hl)
         sub      e
         add      a,8
         ret      m
         cp       13
         ret      p

         ld       hl,(temp1)
         ld       (hl),0

         ld       hl,boss_pwr
         dec      (hl)
         ret      nz
         ld       (hl),0
         dec      hl
         ld       (hl),-1
         ret

 ; *************** In-Game Text *********************************************

in_game_text:
         .db      16,0,"LIVES",0
         .db      16,3,"LEVEL",0
         .db      16,6,"SCORE",0

str_question:
         .db      "-----",0

 ; *************** Display the Screen ***************************************

Display_Screen:
         ld       a,64                       ;Display Image
         ld       hl,GRAPH_MEM+(16*12)
         ld       de,$fc00
dsl:     ld       bc,12
         ldir
         inc      de
         inc      de
         inc      de
         inc      de
         dec      a
         jr       nz,dsl

         ld       a,(lasers)                 ;Display number of lasers
         or       a
         jr       z,nolasers
         add      a,'0'
         ld       (CURSOR_X),de
         call     M_CHARPUT
nolasers:

         ld       hl,$1007                   ;Display Score
         ld       (_curRow),hl
         ld       hl,(score)
         jp       _D_HL_DECI

 ; *************** Handle Your Ship *****************************************

Your_Ship:
         ld       a,(your_status)
         bit      4,a
         jr       nz,you_not_normal
         or       a
         jr       z,ok
         dec      a
         ld       (your_status),a
         ld       hl,(lives)
         ld       a,l
         or       h
         jr       nz,ok
         pop      af
         ret
ok:
         ld       a,%01111110
         out      (1),a
         ld       hl,y
         in       a,(1)
         rra
         ld       b,a

         jr       c,no_down
         ld       a,(hl)
         inc      a
         cp       73
         jr       z,no_down
         ld       (hl),a
no_down: dec      hl
         rr       b
         jr       c,no_left
         ld       a,(hl)
         dec      a
         jr       z,no_left
         ld       (hl),a
no_left: rr       b   
         jr       c,no_right
         ld       a,(hl)
         inc      a
         cp       89
         jr       z,no_right
         ld       (hl),a
no_right:ld       d,(hl)
         inc      hl
         rr       b
         jr       c,no_up
         ld       a,(hl)
         dec      a
         cp       60
         jr       z,no_up
         ld       (hl),a
no_up:
         ld       ix,spr_your_ship

display_common:
         ld       e,(hl)
         jp       drw_spr

you_not_normal:

         ld       hl,(score)
         ld       de,-6
         add      hl,de    
         ld       a,255
         cp       h
         jr       nz,_ok_
         ld       hl,0
_ok_:    ld       (score),hl
         ld       a,(your_status)
         dec      a
         ld       (your_status),a
         inc      a
         and      14
         xor      14
         ld       hl,x-1

explosion_stuff:
         rra
         add      a,a
         add      a,a
         add      a,a
         ld       c,a
         ld       b,0
         ld       ix,spr_explosion
         add      ix,bc
         inc      hl
         ld       d,(hl)
         inc      hl
         jr       display_common

 ; *************** Control Key Processing ***********************************

Misc_Keys:
         ld       a,$BF
         out      (1),a
         nop
         nop
         in       a,(1)
         rla
         jr       nc,e_save
         rla
         jr       nc,e_exit

         ld       a,$FD
         out      (1),a
         nop
         nop
         in       a,(1)
         rra
         jr       nc,pause
         bit      5,a
         ret      nz
e_exit:  pop      af
         ret

e_save:  LD       A,3                        ;Save the game
         ld       (saved_flag),a
         jp       exit_game

pause:   ld       hl,$1901
         ld       (CURSOR_X),hl
         ld       hl,paused_msg
         call     D_ZM_STR)
         ld       de,$2001
         ld       (CURSOR_X),de
         call     D_ZM_STR

wenter:  call     _getkey
         ld       hl,contrst
         cp       kGrMenu
         jr       z,wait_no_enter
         cp       kAdd        
         jr       nz,nic
         ld       a,(hl)
         cp       $1f
         jr       z,wenter
         inc      a
         jr       cc_common
nic:     cp       kSub
         jr       nz,wenter
         ld       a,(hl)
         or       a
         jr       z,wenter
         dec      a
cc_common:
         ld       (hl),a
         out      (2),a
         jr       wenter

wait_no_enter:
         halt
         ld       a,$FD
         out      (1),a
         nop
         nop
         in       a,(1)
         rra
         jr       nc,wait_no_enter
         halt
         ret

paused_msg:
         .db      "Paused - [GRAPH] "
         .db      "to continue",0
         .db      "[+] or [-] to "
         .db      "change contrast",0

 ; *************** Sprite Rendering Routine *********************************

offsets_table:
         .db      128,64,32,16,8,4,2,1
drw_spr: ld       a,d
         and      7
         ld       hl,offsets_table
         ld       c,a
         ld       b,0
         add      hl,bc
         ld       a,(hl)
         ld       (_smc1+1),a

         ld       (_smc1+1),a
         ld       hl,GRAPH_MEM
         ld       a,e
         add      a,a
         add      a,e
         add      a,a
         rl       b
         add      a,a
         rl       b
         srl      d
         srl      d
         srl      d
         add      a,d
         jr       nc,_n1
         inc      b
_n1:     ld       c,a
         add      hl,bc                                    
          
         ld       d,(ix)       
         ld       b,(ix+1)        
_oloop:  push     bc                         ;Save # of rows
         push     hl                         ;Save screen address
         ld       b,d                        ;Load width
         ld       c,(ix+2)                   ;Load one line of image
         inc      ix
_smc1    ld       a,1                        ;Load pixel mask
_iloop:  sla      c                          ;Test leftmost pixel
         jr       nc,_noplot                 ;See if a plot is needed
         ld       e,a                        ;OR pixel with screen
         or       (hl)
         ld       (hl),a
         ld       a,e
_noplot: rrca
         jr       nc,_notedge                ;Test if edge of byte reached
         inc      hl                         ;Go to next byte
_notedge:djnz     _iloop
         pop      hl                         ;Restore address
         ld       bc,12                      ;Go to next line
         add      hl,bc
         pop      bc                         ;Restore data
         djnz     _oloop
         ret

drw_sprw:
         ld       a,d
         and      7                          
         ld       hl,offsets_table          
         ld       c,a                
         ld       b,0                    
         add      hl,bc                
         ld       a,(hl)               

         ld       (wsmc1+1),a
         ld       (wsmc2+1),a
         ld       hl,GRAPH_MEM

         ld       a,e
         add      a,a
         add      a,e
         add      a,a
         rl       b
         add      a,a
         rl       b
         srl      d
         srl      d
         srl      d
         add      a,d
         jr       nc,n1
         inc      b
n1:      ld       c,a
         add      hl,bc                                    
          
         ld       d,(ix)       
         ld       b,(ix+1)        
woloop:  push     bc                         ;Save # of rows
         push     hl                         ;Save screen address
         ld       b,d                        ;Load width
         ld       c,(ix+2)                   ;Load one line of image
         inc      ix
wsmc1    ld       a,1                        ;Load pixel mask
wiloop:  sla      c                          ;Test leftmost pixel
         jr       nc,wnoplot                 ;See if a plot is needed
         ld       e,a                        ;OR pixel with screen
         or       (hl)
         ld       (hl),a
         ld       a,e
wnoplot: rrca
         jr       nc,wnotedge                ;Test if edge of byte reached
         inc      hl                         ;Go to next byte
wnotedge
wsmc2:   cp       1
         jr       z,wover_1

         djnz     wiloop
         pop      hl                         ;Restore address
         ld       bc,12                      ;Go to next line
         add      hl,bc
         pop      bc                         ;Restore data
         djnz     woloop
         ret
wover_1: ld       c,(ix+2)
         inc      ix
         djnz     wiloop
         dec      ix
         pop      hl
         ld       bc,12
         add      hl,bc
         pop      bc
         djnz     woloop
         ret

 ; *************** Enter Next Level *****************************************

Next_Level:
         ld       hl,warped_status
         ld       a,(hl)
         or       a
         jr       z,warped_notyet
         ld       (hl),2
warped_notyet:

         ld       hl,smc_scoring+1
         ld       (hl),100

         xor      a
         ld       (timer),a
         ld       hl,(score)
         ld       de,200
         add      hl,de
         ld       (score),hl
         ld       hl,level
         inc      (hl)
         ld       a,(hl)

         cp       13
         jp       z,won

         call     Update_Level_Number

         call     Load_Level_Data

         LD       HL,enemies
         ld       b,20
         ld       c,1
         ld       a,(enemy_pwr)
         ld       d,110
lie:     ld       (hl),c
         inc      hl
         ld       (hl),a
         inc      hl
         ld       (Hl),d
         inc      hl
         ld       (hl),d
         inc      hl
         djnz     lie

         ld       a,(boss_image)
         inc      a
         jr       nz,_no_weak
         ld       hl,enemies+1
         ld       b,13
no_weak: ld       (hl),1
         inc      hl
         inc      hl
         inc      hl
         inc      hl
         djnz     no_weak
_no_weak:

         ld       a,20
         ld       (enemies_remaining),a
         ld       hl,(level)
         LD       C,3
         xor      a       
         LD       B,$10         
Label1:  ADD      HL,HL
         RLA     
         CP       C
         JR       C,Label0
         SUB      C
         INC      L
Label0:  DJNZ     Label1
         cp       2
         jr       z,warp_it
         or       a
         ret      nz

         ld       (warped_status),a

         ld       hl,(lives)
         inc      hl
         ld       (lives),hl
         call     display_lives

         ld       a,21
         ld       (enemies_remaining),a

         ld       hl,boss_status
         ld       (hl),1
         inc      hl
         ld       (hl),10
         inc      hl
         ld       (hl),30
         inc      hl
         ld       (hl),0
         ret

 ; ************** Generate Warped Level *************************************

warp_it: ld       hl,warped_status
         ld       a,(hl)
         or       a
         ret      nz
         ld       (hl),1

         ld       hl,level
         ld       a,(hl)
         cp       2
         ret      z
         dec      (hl)
         ld       a,(hl)
         ld       hl,smc_scoring+1
         ld       (hl),250

         ld       hl,enemies
         ld       a,10
         ld       (enemies_remaining),a
         ld       b,a

generate_warp_enemies:
         ld       (hl),13
         inc      hl
         ld       (hl),5
         inc      hl
         ld       a,r
         and      63
         add      a,10
         ld       (hl),a
         inc      hl
         xor      a
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         inc      a
         ld       (hl),a
         inc      hl
         ld       (hl),a
         inc      hl
         inc      hl
         djnz     generate_warp_enemies

warp_disp:
         ld       hl,$1004
         ld       (_curRow),hl
         ld       hl,str_question
         jp       _puts

 ; *************** Give Victory Bonus ***************************************

won:     pop      af
         ld       hl,(score)
         ld       de,5000
         add      hl,de
         ld       (score),hl
         ret

 ; *************** Load a Level Data Bank ***********************************

Load_Level_Data:
         ld       hl,level_data-45
         ld       de,45
         ld       bc,(level)
lfl:     add      hl,de
         dec      bc
         ld       a,b
         or       c
         jr       nz,lfl

         ld       a,(level)
         add      a,-10
         jr       nc,noskip

         ld       de,-135
         add      hl,de

         call     noskip

         ld       hl,spr_enemy_4
         ld       (enemy_image),hl
         ld       a,4
         ld       (enemy_pwr),a
         ret

noskip:
         ld       de,enemy_coords
         ld       bc,45
         ldir
         ret

 ; **************** Level Data **********************************************

level_data:

         .db      10,16,20,16,30,16,40,16,50,16
         .db      5,24,15,24,25,24,35,24,45,24
         .db      10,32,20,32,30,32,40,32,50,32
         .db      5,40,15,40,25,40,35,40,45,40
         .dw      spr_enemy_1
         .dw      0
         .db      1

         .db      1,16,14,16,27,16,40,16,53,16
         .db      1,24,14,24,27,24,40,24,53,24
         .db      1,32,14,32,27,32,40,32,53,32
         .db      1,40,14,40,27,40,40,40,53,40
         .dw      spr_enemy_1
         .dw      0
         .DB      1

         .db      1,26,14,26,27,26,40,26,53,26
         .db      1,34,14,34,27,34,40,34,53,34
         .db      1,42,14,42,27,42,40,42,53,42
         .db      1,50,14,50,27,50,40,50,53,50
         .dw      spr_enemy_1
         .dw      spr_boss_1
         .db      1


         .db      5,18,13,18,21,18,29,18,37,18,45,18,53,18
         .db      9,28,17,28,25,28,33,28,41,28,49,28
         .db      5,38,13,38,21,38,29,38,37,38,45,38,53,38
         .dw      spr_enemy_2
         .dw      -1
         .DB      2


         .db      53,28
         .db      52,32
         .db      48,35
         .db      42,38
         .db      35,39
         .db      27,40
         .DB      19,39
         .DB      12,38
         .DB      6,35
         .db      2,32
         .db      1,28
         .db      2,24
         .DB      6,21
         .DB      12,18
         .DB      19,17
         .DB      27,16
         .DB      35,17
         .DB      42,18
         .DB      48,21
         .db      52,24
         .dw      spr_enemy_2
         .dw      0
         .db      2

         .db      1,26,14,26,27,26,40,26,53,26
         .db      1,34,14,34,27,34,40,34,53,34
         .db      1,42,14,42,27,42,40,42,53,42
         .db      1,50,14,50,27,50,40,50,53,50
         .dw      spr_enemy_2
         .dw      spr_boss_2
         .DB      2

         .db      5,18,13,18,21,18,29,18,37,18,45,18,53,18
         .db      9,28,17,28,25,28,33,28,41,28,49,28
         .db      5,38,13,38,21,38,29,38,37,38,45,38,53,38
         .dw      spr_enemy_3
         .dw      -1
         .DB      3

         .DB      01,16,01,22,01,28,01,34,01,40
         .DB      19,16,19,22,19,28,19,34,19,40
         .db      37,16,37,22,37,28,37,34,37,40
         .db      55,16,55,22,55,28,55,34,55,40
         .dw      spr_enemy_3
         .dw      0
         .db      3

         .db      1,26,14,26,27,26,40,26,53,26
         .db      1,34,14,34,27,34,40,34,53,34
         .db      1,42,14,42,27,42,40,42,53,42
         .db      1,50,14,50,27,50,40,50,53,50
         .dw      spr_enemy_3
         .dw      spr_boss_2
         .DB      3

 ; *************** Sprites **************************************************

spr_your_ship:
         .db      7,7
         .DB      %00010000
         .DB      %00111000
         .DB      %10111010
         .DB      %10111010
         .DB      %10111010
         .DB      %11111110
         .DB      %11111110

enemy_warped:
         .db      7,7
         .db      %11000110
         .db      %11101110
         .db      %01111100
         .db      %00111000
         .db      %01111100
         .db      %11101110
         .db      %11000110

spr_bullet_1:
         .db      3,5
         .db      %01000000
         .db      %11100000
         .db      %11100000
         .db      %11100000
         .DB      %11100000

spr_enemy_1:
         .db      6,6
         .db      %10000100
         .db      %10000100
         .db      %11111100
         .DB      %11111100
         .DB      %01111000
         .DB      %00110000

spr_enemy_2:
         .db      6,7
         .db      %10000100
         .db      %11001100
         .db      %11111100
         .db      %10000100
         .db      %10000100
         .db      %01001000
         .db      %00110000

spr_enemy_3:
         .db      6,5
         .db      %10000100
         .db      %11111100
         .DB      %10000100
         .DB      %01001000
         .db      %00110000

spr_enemy_4:
         .db      7,5
         .db      %10000010
         .db      %11000110
         .db      %10101010
         .db      %10010010
         .db      %10000010

spr_boss_1:
         .db      16,8
         .db      %10000000,%00000001
         .db      %11000000,%00000011
         .db      %10111111,%11111101
         .db      %10000001,%10000001
         .db      %10000001,%10000001
         .db      %01000001,%10000010
         .db      %00100001,%10000100
         .db      %00011111,%11111000

spr_boss_2:
         .db      16,8
         .db      %11111111,%11111111
         .db      %11100000,%00000111
         .db      %11100000,%00000111
         .db      %11100000,%00000111
         .db      %11100000,%00000111
         .db      %11110000,%00001111
         .db      %11101000,%00010111
         .db      %01000111,%11100010

spr_enemy_bullet:
         .db      3,3
         .db      %01000000
         .db      %11100000
         .db      %01000000

spr_explosion:                               
         .db      8,6
         .db      %00000000
         .db      %00011100
         .DB      %00111110
         .DB      %01010110
         .DB      %00111000
         .DB      %00000000
         .db      8,6
         .db      %00110000
         .db      %01001110
         .DB      %10111110
         .DB      %01001111
         .DB      %00111000
         .DB      %00011010
         .db      8,6
         .db      %11110011
         .db      %01001110
         .DB      %10110101
         .DB      %01000101
         .DB      %00111110
         .DB      %11011010
         .db      8,6
         .db      %11110011
         .db      %01001110
         .DB      %10110101
         .DB      %01000101
         .DB      %00111110
         .DB      %11011010
         .db      8,6
         .db      %01000001
         .db      %00100110
         .DB      %00010101
         .DB      %01000100
         .DB      %00010010
         .DB      %10011010
         .db      8,6
         .db      %01000010
         .db      %00100000
         .DB      %00000001
         .DB      %01000100
         .DB      %00100010
         .DB      %10001010
         .db      8,6
         .db      %00001000
         .db      %11000010
         .DB      %00000000
         .db      %00100000
         .db      %00000001
         .db      %00110000
         .db      8,6
         .db      %00000100
         .DB      %00000000
         .DB      %01000000
         .DB      %00000000
         .db      %00000001
         .db      %00100100

 ; **************** Title Screen Text ***************************************

title_message:
         .db      "G A L A X I A N",0
title_menu:
         .db      38,20,"Version 2.05",0
         .db      5,28,"Copyright 1998 by"
         .db      " Patrick Davidson",0
         .db      12,36,"E-Mail : "
         .db      "luezma@netscape.net",0
         .db      18,47,"Press [F1] for "
         .db      "instructions",0

instructions:
         .db      10,55,"Press [ENTER] "
         .db      "to begin the game!",0
         .db      28,23,"Arrow keys - move ship",0
         .db      25,30,"[F1] - Cannon"
         .db      "   [F2]-Laser",0
         .db      13,37,"[ENTER] - Pause   "
         .db      "[CLEAR] - Quit",0
         .db      9,44,"[EXIT] - Exit    "
         .db      "[MORE] - Save  exit",0

igc:
         .db      "Ingame Controls",0

 ; *********************** Game Data ****************************************

stored_data_start:

saved_flag:       .db      0

score             .dw      0  
lives             .dw      0       
level             .dw      0         
x                 .db      0        
y                 .db      0        
lasers            .db      0          
ybullets          .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
ebuls             .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
enemies           .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                  .dw      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
boss_status       .db      0           
boss_pwr          .db      0             
boss_x            .db      0         
boss_y            .db      0           
boss_2bytes       .dw      0          
timer             .dw      0          
your_status       .db      0                            
enemies_remaining .db      0          
warped_status     .db      0         
variables_end:

 ; **************** High-Score Data *****************************************

hi_score_str:
         .db      "===== GALAXIAN! ====="
         .db      "  You have a hiscore!"
         .db      "Enter your name:     ",0
hstitle: .db      "=GALAXIAN HIGHSCORES=",0
hsdata:  .dw      25000
         .db      "Galaxian 2.05   ",0
         .dw      20000
         .db      "Galaxian 2.05   ",0
         .dw      15000
         .db      "Galaxian 2.05   ",0
         .dw      10000
         .db      "Galaxian 2.05   ",0
         .dw      7500
         .db      "Galaxian 2.05   ",0
         .dw      5000
         .db      "Galaxian 2.05   ",0
lowest   .dw      4000
         .db      "Galaxian 2.05   ",0
stored_data_end:

         .end
