#include "rom86.h"

#include "ram86.h"

#include "asm86.h"





.org _asm_exec_ram

 call _runindicoff
 call _flushallmenus

; call intitializeLCD	;example of ClearSprite as tile routine

 ld bc,$0810			;coordinate 8,16 (x,y)

 ld (coord),bc

 ld ix,sprite

 ld hl,buffer

 call PutSprite			;put main sprite initially

main:
 halt
 call _getkey

 cp kDown

 call z,down

 cp kUp

 call z,up

 cp kLeft

 call z,left

 cp kRight

 call z,right

 cp kExit

 ret z

 jr main

down:
 ld bc,(coord)			;load coordinates into bc

 push bc

 ld ix,buffer			;input for ClearSprite

 call ClearSprite		;copy background from Putsprite back to screen

 pop bc

 inc c					;new y coordinate (move one pixel down)

 ld (coord),bc			;store the coordinates back

 ld ix,sprite			;input for PutSprite

 ld hl,buffer

 call PutSprite			;put sprite ix to b,c and store the bg to hl

 xor a

 ret

up:
 ld bc,(coord)

 push bc

 ld ix,buffer

 call ClearSprite

 pop bc

 dec c

 ld (coord),bc

 ld ix,sprite

 ld hl,buffer

 call PutSprite

 xor a

 ret

left:
 ld bc,(coord)

 push bc

 ld ix,buffer

 call ClearSprite

 pop bc

 dec b

 ld (coord),bc

 ld ix,sprite

 ld hl,buffer

 call PutSprite

 xor a

 ret

right:
 ld bc,(coord)

 push bc

 ld ix,buffer

 call ClearSprite

 pop bc

 inc b

 ld (coord),bc

 ld ix,sprite

 ld hl,buffer

 call PutSprite

 xor a

 ret

initializeLCD:		;copy sprite2 everywhere to screen
 ld b,0
loop1:
 ld c,0				;for (c < 64)
loop2:				; for (b < 128)
 push bc			;  sprite2.copytile();
 ld ix,sprite2
 call ClearSprite
 pop bc
 ld a,c
 add a,8
 cp 64
 ld c,a
 jr c,loop2
 ld a,b
 add a,8
 cp 128
 ld b,a
 jr c,loop1
 ret

coord:
.dw 0


sprite:
.db %01000010		;sprite

.db %10100101

.db %01011010

.db %00101100

.db %00101100

.db %01011010

.db %10100101

.db %01000010


.db %01000010		;mask

.db %11100111

.db %01111110

.db %00111100

.db %00111100

.db %01111110

.db %11100111

.db %01000010

buffer:
.db 0

.db 0

.db 0

.db 0

.db 0

.db 0

.db 0

.db 0

sprite2:
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101



#include "zmrbw.asm"



.end
